/*
 * @Author: your name
 * @Date: 2020-06-16 14:06:20
 * @LastEditTime: 2020-12-28 17:58:29
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: \keywords\js\background.js
 */
function getSaveToken(callback) {
  chrome.storage.sync.get(['token'], function (result) {
    callback(chrome.runtime.lastError ? null : result.token)
  })
}

function getData(token) {
  // 需要在这里处理异步任务
  let promise = fetch('https://www.keywords.cool/api/v1/keywords/get', {
    method: 'GET',
    headers: {
      token: token,
    },
  })
    .then((res) => {
      // resolve(res)
      if (res.status === 200) {
        //json是返回的response提供的一个方法,会把返回的json字符串反序列化成对象,也被包装成一个Promise了
        return res.json()
      } else {
        return {}
      }
    })
    .catch(function (err) {
      console.log('服务器错误' + err)
    })

  promise = promise
    .then(function (data) {
      //响应的内容
      console.log('getData: ', data)
      return data
    })
    .catch(function (err) {
      console.log(err)
    })
  return promise
}

function postData(token, keywords) {
  // 需要在这里处理异步任务
  let promise = fetch('https://www.keywords.cool/api/v1/keywords/save', {
    method: 'POST',
    body: `keywords=${keywords}&type=1`,
    headers: {
      token: token,
      'Content-Type': 'application/x-www-form-urlencoded',
    },
  })
    .then((res) => {
      // resolve(res)
      if (res.status === 200) {
        //json是返回的response提供的一个方法,会把返回的json字符串反序列化成对象,也被包装成一个Promise了
        return res.json()
      } else {
        return {}
      }
    })
    .catch(function (err) {
      console.log('服务器错误' + err)
    })

  promise = promise
    .then(function (data) {
      //响应的内容
      console.log('postData: ', data)
      return data
    })
    .catch(function (err) {
      console.log(err)
    })
  return promise
}

async function putAllData(keywords) {
  // await执行流程是顺序执行
  getSaveToken(async (saveToken) => {
    let ret = await postData(saveToken, keywords)
    console.log('putAllData->ret: ', ret)
    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
      chrome.tabs.sendMessage(
        tabs[0].id,
        { action: 'SendIt', res: ret },
        function (response) {
          console.log(JSON.stringify(response))
        }
      )
    })
    // let msg = ret.err_msg != 'no' ? ret.err_msg : ret.msg
    // chrome.notifications.create(null, {
    //   type: 'basic',
    //   iconUrl: 'images/icon128.png',
    //   title: '检测到xhr',
    //   message: '油猴酷：' + msg,
    // })
  })
}
// 从服务器请求最近的关键词列表，在百度ajax刷新的时候发送给content.js
function getAllData() {
  // await执行流程是顺序执行
  getSaveToken(async (saveToken) => {
    let ret = await getData(saveToken)
    console.log('getAllData->ret: ', ret)
    chrome.tabs.query({ active: true, currentWindow: true }, function (tabs) {
      chrome.tabs.sendMessage(
        tabs[0].id,
        { action: 'SendIt2', res: ret },
        function (response) {
          console.log(JSON.stringify(response))
        }
      )
    })
    // let msg = '22222222'
    // chrome.notifications.create(null, {
    //   type: 'basic',
    //   iconUrl: 'images/icon128.png',
    //   title: '检测到xhr',
    //   message: '油猴酷：' + msg,
    // })
  })
}
// 请求token是否为空，或是否己过期
function validityToken(token) {
  return new Promise(function (resolve, reject) {
    // 需要在这里处理异步任务
    fetch('https://www.keywords.cool/api/v1/user/amount', {
      method: 'GET',
      headers: {
        token: token,
      },
    })
      .then((res) => {
        resolve(res)
      })
      .catch(function (err) {
        reject('服务器错误' + err)
      })
  })
}

function isValidityToken() {
  // await执行流程是顺序执行
  getSaveToken(async (saveToken) => {
    let ret = await validityToken(saveToken)
    console.log(ret)
    if (ret.err_code === 10091 || ret.err_code === 10001) {
      chrome.tabs.create({ url: 'options.html' })
    }
    if (ret.err_code === 10000 && ret.expire_day <= 1) {
      chrome.tabs.create({ url: 'options.html' })
    }
  })
}

// chrome.webRequest.onBeforeRequest.addListener(
//   function (info) {
//     let url = decodeURIComponent(info.url)
//     let pattern = /(.*)wd=(.*?)&/
//     let keywords = pattern.exec(url)

//     if (info.type == 'xmlhttprequest') {
//       if (
//         keywords[2] == undefined ||
//         keywords[2] == 'undefined' ||
//         /undefined/.test(keywords[2])
//       ) {
//         return { cancel: false }
//       } else {
//         putAllData(keywords[2])
//         getAllData()
//       }
//     }
//     console.log('请求被拦截: ' + info.url)
//     return { cancel: false }
//   },
//   // filters
//   // https://www.baidu.com/s?ie=utf-8&csq=1&pstg=0&mod=2&cqid=9877257300058ca7&istc=921&ver=022sGw1GP3Taje7emfWFye9Z20dyWCCMCY3&chk=5fe9aab8&isid=5BC43DFDC6264020&wd=chrome指纹插件开发&rsf=167670007&rsp=0&f=1&oq=chrome 扩展开发入门&ie=utf-8&rsv_pq=a225d42e0002e1b6&rsv_t=cc56SjrhLYzTJ6/xu1bnXhxuHw7CY0R8xUkJTVrv/a9b3vVy8KQJgk6I4EM&rqlang=cn&rs_src=0&bs=chrome 扩展开发入门&f4s=1&_ck=151180.0.107.84.8.3125.224.1674&isnop=0&rsv_stat=-2
//   // https://www.baidu.com/s?ie=utf-8&csq=1&pstg=0&mod=2&cqid=fb264a5200146866&istc=1429&ver=QwlxGgVSPeXajeyfp_rWyu9Z10Z7XyeRCIi&chk=6224173a&isid=de414b12000af92d&wd=无需审核通过贷款&rsf=100631101&rsp=8&f=1&rs_src=0&rsv_pq=de414b12000af92d&rsv_t=7a53vt6PLvU2PLRIqvoJxyyEhqo61WnIBWHXqNW6MA85MpATNJJdXHv6Ntw&bs=直接就能借到钱的平台&f4s=1&_ck=253147.0.86.98.19.248.2283&isnop=0&rsv_stat=-2
//   {
//     urls: [
//       'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
//       'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
//       'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
//       'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
//     ],
//     types: ['xmlhttprequest'],
//   },
//   // extraInfoSpec
//   ['blocking']
// )
// const blockUrls = [
//   'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
//   'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
//   'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
//   'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
// ]

// blockUrls.forEach((domain, index) => {
//   let id = index + 1

//   chrome.declarativeNetRequest.updateDynamicRules({
//     addRules: [
//       {
//         id: id,
//         priority: 1,
//         action: { type: 'block' },
//         condition: { urlFilter: domain, resourceTypes: ['main_frame'] },
//       },
//     ],
//     removeRuleIds: [id],
//   })
// })

const iframeHosts = [
  'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
  'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*tn=*',
  'https://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
  'http://*.baidu.com/s?ie=utf-8&csq=1&pstg=*&mod=2*bs=*',
]
chrome.runtime.onInstalled.addListener(() => {
  chrome.declarativeNetRequest.updateDynamicRules({
    removeRuleIds: iframeHosts.map((h, i) => {
      console.log(h, i, '2222222')
      return i + 1
    }),
    addRules: iframeHosts.map((h, i) => ({
      id: i + 1,
      priority: 1,
      condition: {
        urlFilter: `${h}`,
        resourceTypes: ['main_frame', 'sub_frame', 'xmlhttprequest'],
      },
      action: {
        type: 'allow',
      },
    })),
  })
})

chrome.declarativeNetRequest.onRuleMatchedDebug.addListener(function (o) {
  console.log('rule matched:', o)
  let url = decodeURIComponent(o.request.url)
  console.log('url: ', url)
  let pattern = /(.*)wd=(.*?)&/
  let keywords = pattern.exec(url)
  console.log('keywords: ', keywords)
  if (o.request.type == 'xmlhttprequest') {
    console.log('keywords[2]:', keywords[2])
    if (
      keywords[2] == undefined ||
      keywords[2] == 'undefined' ||
      /undefined/.test(keywords[2])
    ) {
      return
    } else {
      putAllData(keywords[2])
      getAllData()
    }
  }
})

// function doInCurrentTab(tabCallback) {
//   chrome.tabs.query({ currentWindow: true, active: true }, function (tabArray) {
//     tabCallback(tabArray[0])
//   })
// }
// async function getCurrentTab() {
//   let queryOptions = { active: true, lastFocusedWindow: true }
//   // `tab` will either be a `tabs.Tab` instance or `undefined`.
//   let [tab] = await chrome.tabs.query(queryOptions)
//   return tab
// }
// var activeTabId
// getCurrentTab().then((res) => {
//   console.log(res)
//   // activeTabId = res.id
//   chrome.declarativeNetRequest.getMatchedRules({ tabId: res.id }, (details) =>
//     console.log('details', details)
//   )
// })

// console.log(activeTabId)
// doInCurrentTab(function (tab) {
//   activeTabId = tab.id
// })

// chrome.declarativeNetRequest.getMatchedRules(
//   { tabId: activeTabId },
//   (details) => console.log('details', details)
// )

chrome.windows.onCreated.addListener(function () {
  isValidityToken()
})

chrome.runtime.onInstalled.addListener(function (details) {
  if (details.reason === 'install') {
    // Code to be executed on first install
    // eg. open a tab with a url
    chrome.tabs.create({ url: 'options.html' })
  } else if (details.reason === 'update') {
    // When extension is updated
    chrome.tabs.create({ url: 'options.html' })
  } else if (details.reason === 'chrome_update') {
    // When browser is updated
    console.log('chrome_update')
  } else if (details.reason === 'shared_module_update') {
    // When a shared module is updated
    console.log('shared_module_update')
  }
})

// 监听来自content-script的消息
// chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
//   console.log("收到来自content-script的消息：");
//   console.log(request, sender, sendResponse);
//   sendResponse("我是后台，我已收到你的消息：" + JSON.stringify(request));
// });
