function getSaveToken(callback){
    chrome.storage.sync.get(['token'], function(result) {
        callback(chrome.runtime.lastError ? null : result.token);
    });
}

function init(token){
    $.ajax({
        method: "GET",
        url: "https://www.keywords.cool/api/v1/keywords/by_user?page=1&type=baidu",
        headers: { token: token },
        dataType: "json"
    })
    .done(function( res ) {
        if(res.err_code && res.err_code >10000){
            $("#nav-baidu ul.tab-root").html("<li>"+res.err_msg+"</li>");
        } else {
            console.log(res);
            let data = res.data;
            if(typeof data == "object" && Object.keys(data).length > 0){
                let dataArr = data.data;
                let newDom = createDomList(dataArr);
                $("#nav-baidu ul.tab-root").html(newDom);
            }else {
                $("#nav-baidu ul.tab-root").html("<li>暂时没有数据,请配合油猴脚本先保存数据</li>");
            }
        }
    })
    .fail(function( jqXHR, textStatus ) {
        alert( "Request failed: " + textStatus );
    });
}

function createDomList(dataArr){
    let domStr = "";
    dataArr.forEach(function(item){
        if (item.favorite == 2) {
            domStr += `<li>
                <div><a href="https://www.baidu.com/s?wd=${item.keywords}" target="_blank">${item.keywords}</a></div>
                <div class="right-cont" data-id="${item.id}"><a href="#" class="my-favo"><img src="images/favo16.png" alt=""><a href="#" class="my-del"><img src="images/trash16.png" alt=""></a></a></div>
            </li>`;
        } else {
            domStr += `<li>
                <div><a href="https://www.baidu.com/s?wd=${item.keywords}" target="_blank">${item.keywords}</a></div>
                <div class="right-cont" data-id="${item.id}"><a href="#" class="my-del"><img src="images/trash16.png" alt=""></a></a></div>
            </li>`;
        }
    });
    return domStr;
    
}

$("#nav-baidu ul.tab-root").on("click",".my-favo" ,function(e){
    let id = $(this).parent().data("id");
    alert("favo: " + id);
});

$("#nav-baidu ul.tab-root").on("click", ".my-del",function(e){
    let id = $(this).parent().data("id");
    alert("del: " + id);
});

function toFavorite(id){
    alert("favo: " + id);
}

function toDelete(id){
    alert("del: " + id);
}

getSaveToken((saveToken) => {
    if (saveToken) {
        init(saveToken);
    }
});
